//+------------------------------------------------------------------+
//|                            Symphonie Spikes aka SuperSignal.mq4  |
//|                 Copyright 2006, Nick Bilak, beluck[AT]gmail.com  |
//|                               Modified by mtuppers[AT]gmail.com  |
//|			                            took away time, add periods  |
//|   Modified by MaryJane: histogram version a-la Cycle Identifier  |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_minimum -1.2
#property indicator_maximum 1.2
#property indicator_buffers 5
#property indicator_color1 DarkGray
#property indicator_color2 Red
#property indicator_color3 DodgerBlue
#property indicator_color4 White
#property indicator_color5 White
#property indicator_width1 2
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 1
#property indicator_width5 1

//input properties

extern int  timeFrame       = 0;
extern int  dist2           = 48;
extern int  dist1           = 32;
extern bool alertsOn        = true;
extern string note1 = "alert all = 0",
              note2 = "buy only = 1, sell only = 2",
              note3 = "extreme buy or extreme sell = 3";
extern int  alertsOption    = 3;
extern bool alertsOnCurrent = false;
extern bool alertsMessage   = false;
extern bool alertsSound     = true;
extern bool alertsEmail     = false;
extern bool alertsNotify    = true;

double b1[];
double b2[];
double b3[];
double b4[];
double b5[];

int init()
{
   SetIndexBuffer(0,b1);
   SetIndexBuffer(1,b2);
   SetIndexBuffer(2,b3);
   SetIndexBuffer(3,b4);
   SetIndexBuffer(4,b5);
   SetIndexStyle(0,DRAW_LINE);
      timeFrame = MathMax(timeFrame,Period());
   for (int i=1; i<5; i++) {SetIndexStyle(i,DRAW_HISTOGRAM);}
   for (i=0; i<5; i++) {SetIndexLabel(i,NULL);}
   
   return(0);
}
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit,hhb,llb,hhb1,llb1;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;
           limit=MathMax(limit,dist1*timeFrame/Period());
           limit=MathMax(limit,dist2*timeFrame/Period());

   //
   //
   //
   //
   //

   for (i=limit;i>=0;i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
         int x = iBarShift(NULL,timeFrame,Time[i+1]);

         b1[i] = 0;
         b2[i] = EMPTY_VALUE;
         b3[i] = EMPTY_VALUE;
         b4[i] = EMPTY_VALUE;
         b5[i] = EMPTY_VALUE;

         if (x!=y)
         {
            hhb1 = iHighest(NULL,timeFrame,MODE_HIGH,dist1,y-dist1/2);
            llb1 = iLowest(NULL,timeFrame,MODE_LOW,dist1,y-dist1/2);
            hhb  = iHighest(NULL,timeFrame,MODE_HIGH,dist2,y-dist2/2);
            llb  = iLowest(NULL,timeFrame,MODE_LOW,dist2,y-dist2/2);

            if (y==hhb)  {b2[i]= 1; b1[i]= 1;}
            if (y==llb)  {b3[i]=-1; b1[i]=-1;}
            if (y==hhb1) {b4[i]= 1; b1[i]= 1;}
            if (y==llb1) {b5[i]=-1; b1[i]=-1;}
         }            
      }
      
   //
   //
   //
   //
   //
   
   if (alertsOn)
      {
         int forBar = 1;
         if (alertsOnCurrent) forBar = 0;
         if (alertsOption == 0)  //alert on all direction
            {
            if (b2[forBar] != EMPTY_VALUE && b4[forBar] != EMPTY_VALUE) doAlert("extreme sell");
            if (b2[forBar] != EMPTY_VALUE && b4[forBar] == EMPTY_VALUE) doAlert("sell");
            if (b2[forBar] == EMPTY_VALUE && b4[forBar] != EMPTY_VALUE) doAlert("minor sell or exit buy");
            if (b3[forBar] != EMPTY_VALUE && b5[forBar] != EMPTY_VALUE) doAlert("extreme buy");
            if (b3[forBar] != EMPTY_VALUE && b5[forBar] == EMPTY_VALUE) doAlert("buy");
            if (b3[forBar] == EMPTY_VALUE && b5[forBar] != EMPTY_VALUE) doAlert("minor buy or exit sell");
            }
         if (alertsOption == 1)  //alert on buy only
            {
            if (b3[forBar] != EMPTY_VALUE && b5[forBar] != EMPTY_VALUE) doAlert("extreme buy");
            if (b3[forBar] != EMPTY_VALUE && b5[forBar] == EMPTY_VALUE) doAlert("buy");
            if (b3[forBar] == EMPTY_VALUE && b5[forBar] != EMPTY_VALUE) doAlert("minor buy or exit sell");
            }
         if (alertsOption == 2)  //alert on sell only
            {
            if (b2[forBar] != EMPTY_VALUE && b4[forBar] != EMPTY_VALUE) doAlert("extreme sell");
            if (b2[forBar] != EMPTY_VALUE && b4[forBar] == EMPTY_VALUE) doAlert("sell");
            if (b2[forBar] == EMPTY_VALUE && b4[forBar] != EMPTY_VALUE) doAlert("minor sell or exit buy");
            }
         if (alertsOption == 3)  //alert on extreme buy or sell
            {
            if (b3[forBar] != EMPTY_VALUE && b5[forBar] != EMPTY_VALUE) doAlert("extreme buy");
            if (b2[forBar] != EMPTY_VALUE && b4[forBar] != EMPTY_VALUE) doAlert("extreme sell");
            }
      }
      
  return(0);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   string TimePeriod;
   
   if (Period()== 1)       TimePeriod = "1 MIN";
   if (Period()== 5)       TimePeriod = "5 MIN";
   if (Period()== 15)      TimePeriod = "15 MIN";
   if (Period()== 30)      TimePeriod = "30 MIN";
   if (Period()== 60)      TimePeriod = "1 HR";
   if (Period()== 240)     TimePeriod = "4 HR";
   if (Period()== 1440)    TimePeriod = "DAILY";
   if (Period()== 10080)   TimePeriod = "WEEKLY";
   if (Period()== 43200)   TimePeriod = "MONTHLY";

      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ", TimePeriod, " Symphonie Spike : ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Symphonie Spike "),message);
             if (alertsNotify)  SendNotification(message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}